import sys
if len(sys.argv) != 3:
    print "command is 'pyMPI <python driver code> <script name> <number of time steps>'"
    sys.exit(1)
import mpi
mpi.initialized()
import paraview
import paraview.vtk as vtk
 
# initialize and read input parameters
paraview.options.batch = True
paraview.options.symmetric = True
 
def _refHolderMaker(obj):
    def _refHolder(obj2, string):
  tmp = obj
    return _refHolder
 
def coProcess(grid, time, step, scriptname):
    import libvtkCoProcessorPython #on windows do import vtkCoProcessorPython
    try:
  cpscript = __import__(scriptname) # this doesn't seem to work properly for me
    except:
        print 'Cannot find ', scriptname, ' -- no coprocessing will be performed.'
        return
 
    datadescription = libvtkCoProcessorPython.vtkCPDataDescription()
    datadescription.SetTimeData(time, step)
    datadescription.AddInput("input")
    cpscript.RequestDataDescription(datadescription)
    inputdescription = datadescription.GetInputDescriptionByName("input")
    if inputdescription.GetIfGridIsNecessary() == False:
        return
 
    import paraview.simple
    import paraview.vtk as vtk
    import paraview.numpy_support
 
    inputdescription.SetGrid(grid)
    cpscript.DoCoProcessing(datadescription)
 
try:
    numsteps = int(sys.argv[2])
except ValueError:
    print 'the last argument should be a number'
    numsteps = 10
 
 
for step in range(numsteps):
    # assume simulatione time is from 0 to 1
    time = step/float(numsteps-1)
 
    # create the input to the coprocessing library.  normally
    # this will come from the adaptor
    imageData = vtk.vtkImageData()
    imageData.SetOrigin(0, 0, 0)
    imageData.SetSpacing(.1, .1, .1)
    imageData.SetDimensions(10, 12, 12)
    pointArray = vtk.vtkDoubleArray()
    pointArray.SetNumberOfTuples(imageData.GetNumberOfPoints())
    for i in range(imageData.GetNumberOfPoints()):
        pointArray.SetValue(i, i)
    pointArray.SetName("pointData")
    imageData.GetPointData().AddArray(pointArray)
 
    # "perform" coprocessing.  results are outputted only if
    # the passed in script says we should at time/step
    coProcess(imageData, time, step, sys.argv[1])
 
mpi.finalized()

